#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 500'000;
int k;
vector<string> vFrag;
vector<int> answer;

void radixSort(int pos, vector<int>& vIdx, int lb, int rb) {
    if (lb-1 <= k && k <= rb+1 && vIdx.size() == 1) {
        answer.push_back(vIdx[0]);
        return;
    }
    map<char, vector<int>> table;
    vector<char> keys {' ', 'a', 'c', 'g', 'n', 't'};
    for (char& key : keys) {
        table.insert({key, vector<int>()});
    }
    for (int& idx : vIdx) {
        if (vFrag[idx].size() == pos) {
            table[' '].push_back(idx);
        } else {
            table[vFrag[idx][pos]].push_back(idx);
        }
    }
    for (char& key : keys) {
        if (table[key].empty()) {
            continue;
        }
        rb = lb + table[key].size() - 1;
        if (lb-1 <= k && k <= rb+1) {
            radixSort(pos + 1, table[key], lb, rb);
        }
        lb = rb + 1;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> k;
    vFrag.reserve(MAX_N + 1);
    vFrag.push_back("NULL");
    istream_iterator<string> cin_iter(cin);
    istream_iterator<string> eos;
    copy(cin_iter, eos, back_inserter(vFrag));
    
    vector<int> vIdx(vFrag.size() - 1, 0);
    for (int i = 0; i < vIdx.size(); i++) {
        vIdx[i] = i + 1;
    }
    
    answer.reserve(3);
    radixSort(0, vIdx, 1, vIdx.size());
    copy(answer.begin(), answer.end(), ostream_iterator<int>(cout, "\n"));
}