#include <iostream>
#include <queue>
#include <string>
#include <map>
#include <vector>

#define max(a,b) (a>b)?a:b
using namespace std;

vector<string> arr;
queue<int> q;
queue<int> answer;
int k;
int maxLen = 0;
int index;

int findQ(queue<int> tmp, int idx) {
	int i = 1;
	while (!tmp.empty()) {
		if (i == idx) return tmp.front();
		tmp.pop();
		i++;
	}
}

void radixSort(int find) {
	if (index >= maxLen && q.size() != 1) {
		answer.push(findQ(q, find));
		return;
	}
	if (q.size() == 1) {
		answer.push(q.front());
		return;
	}
	map<char, queue<int>> m;
	map<char, queue<int>>::iterator iter;

	while (!q.empty()) {
		int cur = q.front();
		q.pop();

		if (arr[cur].size() < index) {
			m['A'].push(cur);
		}
		else {
			m[arr[cur][index]].push(cur);
		}
	}

	for (iter = m.begin(); iter != m.end(); iter++) {
		find -= (*iter).second.size();
		if (find <= 0) {
			find += (*iter).second.size();
			q = (*iter).second;

			index++;
			radixSort(find);
			break;
		}
	}
}

int main(void) {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int num = 1;
	string fragment;

	cin >> k;

	queue<int> tmp;
	arr.push_back("");
	while (cin >> fragment) {
		tmp.push(num++);
		arr.push_back(fragment);
		maxLen = max(maxLen, fragment.size());
	}

	q = tmp;
	index = 0;
	radixSort(k - 1);
	q = tmp;
	index = 0;
	radixSort(k);
	q = tmp;
	index = 0;
	radixSort(k + 1);

	while (!answer.empty()) {
		cout << answer.front() << '\n';
		answer.pop();
	}

	return 0;
}